//*****************************************************************************
//
//	Grundinitialisierung des ATmega
//
//*****************************************************************************

/* extended fuses 1..0 */
// M103C    = 0;
// WDTON    = 0;

/* fuses high bits 7..0 */
// OCDEN    = 1;
// JTAGEN   = 1;
// SPIEN    = 1;
// CKOPT    = 1;

// EESAVE   = 0;
// BOOTSZ1  = 1;
// BOOTSZ0  = 1;
// BOOTRST  = 0;

/* fuses low bits 7..0 */
// BODLEVEL = 0;
// BODEN    = 0;
// SUT1     = 0;
// SUT0     = 1;

// CKSEL3   = 0;
// CKSEL2   = 0;
// CKSEL1   = 0;
// CKSEL0   = 0;

#include <iom128v.h>

//*****************************************************************************
//	Initialisierung nach RESET
//  Input:	-
//	Output:	-
//*****************************************************************************


unsigned char INIT(void)
{
unsigned char uc_Start;

  SREG &= 0x7F;	//global INT aus                   
  XDIV  = 0x00; //xtal divider
  XMCRA = 0x00; //external memory
 
  uc_Start = MCUCSR;
  MCUCR = 0x00;  
  EICRA = 0x00; //extended ext ints
  EICRB = 0x00; //extended ext ints
  EIMSK = 0x00;
  TIMSK = 0x00; //timer interrupt sources
  ETIMSK = 0x00; //extended timer interrupt sources


// Input/Output Ports initialization as input
// Port A
  DDRA  = 0x00;
  PORTA = 0x00;

// Port B
  DDRB  = 0x00;
  PORTB = 0x00;

// Port C
  DDRC  = 0x00;
  PORTC = 0x00;

// Port D
  DDRD  = 0x00;
  PORTD = 0x00;

// Port E
  DDRE  = 0x00;
  PORTE = 0x00;

// Port F
  DDRF  = 0x00;
  PORTF = 0x00;
 
// Port G
  DDRG  = 0x00;
  PORTG = 0x00;
	
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Output Compare
// OC0 output: Disconnected
  TCCR0=0x00;
  ASSR=0x00;
  TCNT0=0x00;
  OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Output Compare
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
  TCCR1A=0x00;
  TCCR1B=0x00;
  TCNT1H=0x00;
  TCNT1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x00;
  OCR1BH=0x00;
  OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Output Compare
// OC2 output: Disconnected
  TCCR2=0x00;
  TCNT2=0x00;
  OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Output Compare
// OC3A output: Discon.
// OC3B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
  TCCR3A=0x00;
  TCCR3B=0x00;
  TCNT3H=0x00;
  TCNT3L=0x00;
  OCR3AH=0x00;
  OCR3AL=0x00;
  OCR3BH=0x00;
  OCR3BL=0x00;
  
// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
  ACSR=0x80;

  SREG |= 0x80;  //global INT an
  return(uc_Start);
}


