//*****************************************************************************
//
//	Grundinitialisierung des SPI Bus
//
//*****************************************************************************
#include <iom128v.h>
#include "m128int.h"
#include "spibus.h"
#include "watchdog.h"


#pragma interrupt_handler SPI_INT:SPI_STC


//*****************************************************************************
//	SPI Interrupt
//  Input:	-
//	Output:	-
//*****************************************************************************
void SPI_INT(void)
{
}


//*****************************************************************************
//	Initialisierung SPI als Master
//  Input:	-
//	Output:	-
//*****************************************************************************
void SPI_Init(unsigned char CReg)
{
  DDRB  &= 0xF7;
  DDRB  |= 0x07;
  PORTB |= 0x09;

  SPCR = CReg | 0x40;    //control register. ohne INT
//  SPCR = CReg | 0xC0;    //control register. mit INT
}


//*****************************************************************************
//	Schreiben auf SPI Bus
//  Input:	-
//	Output:	-
//*****************************************************************************
void SPI_Write(unsigned char byte)
{
  while ((SPSR & 0x80)!= 0)
  {
    watchdog_reset();
  }

  SPDR = byte;

  while ((SPSR & 0x80)== 0)
  {
    watchdog_reset();
  }
  
  byte = SPDR;
}


//*****************************************************************************
//	Lesen vom SPI Bus, Start durch Schreiben von 0x00 auf SPI Bus
//  Input:	-
//	Output:	-
//*****************************************************************************
unsigned char SPI_Read(unsigned char uc_x)
{
  while ((SPSR & 0x80)!= 0)
  {
    watchdog_reset();
  }
  
  SPDR = uc_x;

  while ((SPSR & 0x80)== 0)
  {
    watchdog_reset();
  }
  
  return SPDR;
}


//*****************************************************************************
//	Lesen vom SPI Bus, ohne Start durch Schreiben auf SPI Bus
//  Input:	-
//	Output:	-
//*****************************************************************************
unsigned char SPI_ReadData(void)
{
  return SPDR;
}


